/*! 
  @file rx_mesh_e.h

  @brief gbV\̒`
  		 - GbWǉ
  		 - _CGbWCʂ̒ǉE폜ɑΉ
 
  @author Makoto Fujisawa
  @date 2012-03
*/
// FILE --rx_mesh_e.h--

#ifndef _RX_MESH_E_H_
#define _RX_MESH_E_H_


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "rx_mesh.h"


//-----------------------------------------------------------------------------
// bVNX
//-----------------------------------------------------------------------------
//! GbW
struct rxEdge
{
	int v[2];		//!< GbW[̒_CfbNX
	set<int> f;		//!< GbWɂȂ|S
	double len;		//!< GbW
	int attribute;	//!< 
};

//! g|SIuWFNg(GbWǉ)
class rxPolygonsE : public rxPolygons
{
public:
	vector<rxEdge> edges;		//!< GbW
	vector< set<int> > vedges;	//!< _ɂȂGbW
	vector< set<int> > vfaces;	//!< _ɂȂ|S
	vector< set<int> > fedges;	//!< |SɊ܂܂GbW

	vector<Vec3> vcol;			//!< _F

public:
	//! RXgN^
	rxPolygonsE() : rxPolygons() {}
	//! fXgN^
	virtual ~rxPolygonsE(){}

	//! 
	void Clear(void)
	{
		vertices.clear();
		normals.clear();
		faces.clear();
		materials.clear();
		edges.clear();
		vedges.clear();
		vfaces.clear();
		fedges.clear();
	}

};


//-----------------------------------------------------------------------------
// bVf[^ҏW֐
//-----------------------------------------------------------------------------

/*!
 * 폜tOt̃|S폜
 * @param[inout] src ύX|S
 * @param[in] del_attr 폜ʂɓo^ꂽ
 */
static int DeletePolygon(rxPolygonsE *src, int del_attr)
{
	vector<rxFace>::iterator iter = src->faces.begin();
	int d = 0;
	while(iter != src->faces.end()){
		if(iter->attribute == del_attr){
			iter = src->faces.erase(iter);
			d++;
		}
		else{
			++iter;
		}
	}
	return d;
}


/*!
 * AuIy[^Œ_Fairing
 * @param[inout] obj g|SIuWFNg
 * @return ̏ꍇ1
 */
static int VertexFairingByUmbrella(rxPolygonsE &obj)
{
	int vnum = (int)obj.vertices.size();
	if(!vnum || obj.vedges.empty()) return 0;

	for(int i = 0; i < vnum; ++i){
		Vec3 newpos = obj.vertices[i];

		// _ɂȂGbW𑖍
		int en = 0;
		set<int>::iterator eiter = obj.vedges[i].begin();
		do{
			int v1, v2;
			v1 = obj.edges[*eiter].v[0];
			v2 = obj.edges[*eiter].v[1];

			newpos += obj.vertices[(v1 != i ? v1 : v2)];
			en++;
		}while(++eiter != obj.vedges[i].end());

		newpos /= (double)(en+1);

		obj.vertices[i] = newpos;
	}

	return 1;
}


/*!
 * _ɐڑ|ST
 * @param[inout] obj g|SIuWFNg
 * @return ̏ꍇ1
 */
static int SearchVertexFace(rxPolygonsE &obj)
{
	int vnum = (int)obj.vertices.size();
	if(!vnum) return 0;

	obj.vfaces.clear();
	obj.vfaces.resize(vnum);

	rxFace* face;
	int pnum = (int)obj.faces.size();

	// S|ST
	for(int i = 0; i < pnum; ++i){
		face = &obj.faces[i];
		for(int j = 0; j < face->size(); ++j){
			int v = face->at(j);
			obj.vfaces[v].insert(i);
		}
	}

	return 1;
}

/*!
 * GbWf[^쐬
 * @param[inout] obj g|SIuWFNg
 * @return GbW
 */
static int SearchEdge(rxPolygonsE &obj)
{
	int edge_count = 0;
	int vnum = (int)obj.vertices.size();
	int pnum = (int)obj.faces.size();

	obj.vedges.clear();
	obj.vedges.resize(vnum);
	obj.fedges.clear();
	obj.fedges.resize(pnum);
	obj.edges.clear();

	rxFace* face;
	int vert_idx[2];


	// S|ST
	for(int i = 0; i < pnum; ++i){
		face = &obj.faces[i];
		vnum = face->size();

		for(int j = 0; j < vnum; ++j){
			// GbW_1
			vert_idx[0] = face->at(j);
			// GbW_2
			vert_idx[1] = (j == vnum-1) ? face->at(0) : face->at(j+1);

			// dŐ̃`FbN
			bool overlap = false;
			set<int>::iterator viter;

			// GbW_1̃`FbN
			if((int)obj.vedges[vert_idx[0]].size() > 0){
				// _ɂȂĂGbW(ɓo^ꂽ)𒲂ׂ
				viter = obj.vedges[vert_idx[0]].begin();
				do{
					int v1, v2;
					v1 = obj.edges[*viter].v[0];
					v2 = obj.edges[*viter].v[1];

					if( (vert_idx[0] == v1 && vert_idx[1] == v2) || (vert_idx[1] == v1 && vert_idx[0] == v2) ){
						overlap = true;
						obj.edges[*viter].f.insert(i);	// ʂGbWɉ
						obj.fedges[i].insert(*viter);	// GbWʂɉ
					}
				}while(++viter != obj.vedges[vert_idx[0]].end());
			}

			// GbW_2̃`FbN
			if((int)obj.vedges[vert_idx[1]].size() > 0){
				// _ɂȂĂGbW(ɓo^ꂽ)𒲂ׂ
				viter = obj.vedges[vert_idx[1]].begin();
				do{
					int v1, v2;
					v1 = obj.edges[*viter].v[0];
					v2 = obj.edges[*viter].v[1];

					if( (vert_idx[0] == v1 && vert_idx[1] == v2) || (vert_idx[1] == v1 && vert_idx[0] == v2) ){
						overlap = true;
						obj.edges[*viter].f.insert(i);	// ʂGbWɉ
						obj.fedges[i].insert(*viter);	// GbWʂɉ
					}
				}while(++viter != obj.vedges[vert_idx[1]].end());
			}

			// dŐȂ̏ꍇCVKɒǉ
			if(!overlap){
				obj.edges.push_back(rxEdge());
				obj.edges[edge_count].v[0] = vert_idx[0];
				obj.edges[edge_count].v[1] = vert_idx[1];
				obj.edges[edge_count].f.insert(i);

				obj.vedges[vert_idx[0]].insert(edge_count);
				obj.vedges[vert_idx[1]].insert(edge_count);
				obj.fedges[i].insert(edge_count);

				edge_count++;
			}

		}
	}

	return edge_count;
}


/*!
 * GbWvZ
 * @param[inout] obj g|SIuWFNg
 * @return GbW
 */
static int CalEdgeLength(rxPolygonsE &obj)
{
	int en = (int)obj.edges.size();

	if(en == 0) return 0;

	int vn = (int)obj.vertices.size();

	rxEdge *edge;
	for(int i = 0; i < en; ++i){
		edge = &obj.edges[i];

		int v0 = edge->v[0];
		int v1 = edge->v[1];

		edge->len = norm(obj.vertices[v0]-obj.vertices[v1]);
	}

	return 1;
}


#endif // #ifndef _RX_MESH_E_H_
